[Package]
Name="delacor_lib_dqmh_toolkit"
Version="6.1.0.90"
Release=""
ID=6d9c62acf1a06038e568ccbfcca471f0
File Format="vip"
Format Version="2014"
Display Name="DQMH"


[Description]
Description="The Delacor Queued Message Handler (short: DQMH) toolkit is a freely available reference design (also called a template or framework) for LabVIEW. It expands on the NI QMH by providing safe, event-based message handling and scripting tools to make development easy, encourage same style between different developers in the same project and improve efficiency. Today, the DQMH is arguably the most popular LabVIEW framework out there.\0A\0AThe LabVIEW ecosystem often sees teams of software developers with members of varying proficiency. Teams that are growing rapidly. Teams that need to onboard new members regularly. Teams that need to employ subcontractors, and teams that dont want to be dependent on a single source. DQMH was created with these small teams in mind!\0A\0ATheres a vast amount of content available: An exceptionally detailed manual, a plethora of videos and presentations, even podcasts! All of this makes it really easy to get new users of all proficiency levels up to speed very quickly. On top of that, there are lots of consultants  both the DQMH Trusted Advisors and other 3rd parties  who are happy to offer courses, trainings and workshops for DQMH.\0A\0AThis package installs all the packages needed for the DQMH toolkit:\0ADQMH Palette\0ADQMH Project Template\0ADQMH Event Scripter\0ADQMH Thermal Chamber Examples"
Summary="DQMH is the Future of Team-Based LabVIEW Development!"
License=""
Copyright="Copyright (c) 2022, DQMH Consortium"
Distribution=""
Vendor="DQMH Consortium"
URL="dqmh.org"
Packager="DQMH Consortium"
Demo="FALSE"
Release Notes="====== DQMH 6.1 ======\0A* DQMH 6.1.0.90\0A* DQMH Palette 6.1.0.18\0A* DQMH Project Template 6.1.0.94\0A* DQMH Event Scripter 6.1.0.128\0A* DQMH Thermal Chamber Example 6.1.0.51\0A\0ARelease notes can be found at https://dqmh.org/release-notes\0AThe online version includes links to forum posts and blog posts relevant to the release notes.\0AFor DQMH Help go to Help>>DQMH Consortium>>DQMH Help....\0A\0ARelease notes for DQMH 6.1\0AThis is the first DQMH release that drops support for LabVIEW 2014.\0A\0A### Major new features\0A#744 Validate tests for broken VIs. Return a validate failure if the Main VI and/or Tester VI for a module are broken.\0A#733 More custom fields in Module Template. When creating a DQMH Module Template, the user can now specify default values for Tester virtual folder, Module virtual folder, and relative path location for the new module. Then, whenever that template is used in the New DQMH Module dialog, those fields are pre-populated with the values from the module template and can be changed by the user. The last used virtual folder for tester, virtual folder for module, and relative path on disk for module are stored in the LabVIEW INI file. These will then be used when creating the next module with the Add New Module UI. Additionally, there is now a 'Reset path and folder fields to default' button in the UI so the user can see what the default paths for different module types are if he doesn't want to use his last-used path.\0A#734 New Scripting API for DQMH. VIs currently implemented are:\0A  - Get all modules in a project\0A  - Get all events in a module library\0A  - Get all callers of a request VI in the project\0A  - Get all VIs registered for a broadcast in the project\0A#735 Quick Drop plugin for calling DQMH tools. The Ctrl-E quick drop shortcut will now launch all DQMH scripting tools. Read the description of the plugin (Quick Drop > Configure > Ctrl-Key Shortcuts > Launch DQMH Tool) to see the commands for launching each tool.\0A#732 Ignore individual validation results. The Validation Results UI now allows you to right-click any validation failure and choose to ignore it for future validation runs. There is also a button in the results UI that lets you manage the validation failures for your modules. Note that this information is currently stored in a (human-readable) tag in the module .lvlib XML. The headless validator will fire a Validation Finished event even if the validation didn't start due to an error. Validation tests that can flag individual VIs will check for the Issue Text in the VI description and if so, will not return a failure.\0A#729 New 'Show Diagram on Init' data member All our shipping modules (Project Template, CML Template, Module Template, and shipping example) have been updated to have a new 'show main VI diagram on init' checkbox on their testers. This parameter is wired to the Start Module VI for those modules and implements the new functionality where, on startup, the module main VI diagram is displayed and Retain Wire Values is enabled. A validate+fixer has been added to update old modules to include this new functionality.\0A#737 New progress VI for headless validation. The 'Obtain Progress Events.vi' will be on the DQMH Scripting palette and will allow the user to monitor the progress of a headless validation via events.\0A#741 Rename 'Delacor' menu to 'DQMH Consortium'. Rename the Tools > Delacor menu to Tools > DQMH Consortium.\0A\0A\0A### DQMH Palette\0A#734 New Scripting API for DQMH. VIs currently implemented are:\0A  - Get all modules in a project\0A  - Get all events in a module library\0A  - Get all callers of a request VI in the project\0A  - Get all VIs registered for a broadcast in the project\0A#735 Quick Drop plugin for calling DQMH tools. The Ctrl-E quick drop shortcut will now launch all DQMH scripting tools. Read the description of the plugin (Quick Drop > Configure > Ctrl-Key Shortcuts > Launch DQMH Tool) to see the commands for launching each tool.\0A#729 New 'Show Diagram on Init' data member All our shipping modules (Project Template, CML Template, Module Template, and shipping example) have been updated to have a new 'show main VI diagram on init' checkbox on their testers. This parameter is wired to the Start Module VI for those modules and implements the new functionality where, on startup, the module main VI diagram is displayed and Retain Wire Values is enabled. A validate+fixer has been added to update old modules to include this new functionality.\0A#737 New progress VI for headless validation. The 'Obtain Progress Events.vi' will be on the DQMH Scripting palette and will allow the user to monitor the progress of a headless validation via events.\0A#756 New Legal and Version Info Constant VIs.\0A#723 About VI. There is now an 'About DQMH' VI in the DQMH palette. The Project Template, CML Template, Module Template, and Shipping Example have all been updated with a button in various UIs to launch the About box.\0A\0A\0A### Module Template\0A#733 More custom fields in Module Template. When creating a DQMH Module Template, the user can now specify default values for Tester virtual folder, Module virtual folder, and relative path location for the new module. Then, whenever that template is used in the New DQMH Module dialog, those fields are pre-populated with the values from the module template and can be changed by the user. The last used virtual folder for tester, virtual folder for module, and relative path on disk for module are stored in the LabVIEW INI file. These will then be used when creating the next module with the Add New Module UI. Additionally, there is now a 'Reset path and folder fields to default' button in the UI so the user can see what the default paths for different module types are if he doesn't want to use his last-used path.\0A\0A\0A### DQMH Scripter\0A#747 Don't list modules with RT testers already. When running the Create RT Tester utility, don't list modules in the module list that already have an RT tester.\0A#728 Module description field. When running the Create New Module utility, there is now an optional description field for specifying a module description (which will populate the Description field of the module library file).\0A#748 Improve scripting for 'event only' modules. The New Event scripting tool now works properly for scripting the new event in the main VI even if the EHL does not have a Delacor Message Queue tunnel input\0A#734 New Scripting API for DQMH. VIs currently implemented are:\0A  - Get all modules in a project\0A  - Get all events in a module library\0A  - Get all callers of a request VI in the project\0A  - Get all VIs registered for a broadcast in the project\0A#722 Don't try to parse PPLs. When parsing the project to find DQMH modules, ignore modules inside PPLs (as they can't be modified or inspected with our scripting tools).\0A#727 Remove extraneous text from error labels. Renamed the Reply Payload error cluster to just error instead of [request name] error. Updated the scripting code to create new reply payload error clusters with the simple label error.\0A#746 Improve Error Reported error reporting. Improved the code in the Error Reported broadcast of the tester VIs to return more useful error information. This change was made to the testers in the module template, project template, and CML template. There is also a validate+fixer to fix the issue in the existing code.\0A#749 New Null Broadcast Events--constant VI. Added the new 'Null Broadcast Eventsconstant.vi' to all template DQMH modules. Also added a new validate+fixer to add this VI to old modules that don't have it.\0A#741 Rename 'Delacor' menu to 'DQMH Consortium'. Rename the Tools > Delacor menu to Tools > DQMH Consortium.\0A\0A\0A### DQMH Validation Tool\0A#744 Validate tests for broken VIs. Return a validate failure if the Main VI and/or Tester VI for a module are broken.\0A#745 Wired Start Async Call output. New validate module test that returns a failure if the user has wired the VI Reference output of the Start Asynchronous Call function in the Start Module VI of a cloneable module.\0A#743 Improve namespace handling in timeout fixer. The fixer that adds the Timeout Error subVI to a Request and Wait for Reply VI now does a better job with only parsing VIs that are directly part of the module namespace (and ignores sublibraries that may have identically-named VIs)\0A#732 Ignore individual validation results. The Validation Results UI now allows you to right-click any validation failure and choose to ignore it for future validation runs. There is also a button in the results UI that lets you manage the validation failures for your modules. Note that this information is currently stored in a (human-readable) tag in the module .lvlib XML. The headless validator will fire a Validation Finished event even if the validation didn't start due to an error. Validation tests that can flag individual VIs will check for the Issue Text in the VI description and if so, will not return a failure.\0A#746 Improve Error Reported error reporting. Improved the code in the Error Reported broadcast of the tester VIs to return more useful error information. This change was made to the testers in the module template, project template, and CML template. There is also a validate+fixer to fix the issue in the existing code.\0A#749 New Null Broadcast Events--constant VI. Added the new 'Null Broadcast Eventsconstant.vi' to all template DQMH modules. Also added a new validate+fixer to add this VI to old modules that don't have it.\0A#752 Validate+fixer for Stop Module event ordering. The new fixer will update the Wait on Stop Sync VI to use the new mechanism to register for Module Did Stop before firing the Stop Module event. The fixer also fixes up the two callers of Wait on Stop Sync (Stop Module.vi and Close Module.vi).\0A#752 Add semaphores to singleton modules. Project Template, CML Template, and Module Template updated to include semaphore synchronization in all their semaphore modules. There is also a validate+fixer to detect this issue in older modules and update them.\0A#729 New 'Show Diagram on Init' data member All our shipping modules (Project Template, CML Template, Module Template, and shipping example) have been updated to have a new 'show main VI diagram on init' checkbox on their testers. This parameter is wired to the Start Module VI for those modules and implements the new functionality where, on startup, the module main VI diagram is displayed and Retain Wire Values is enabled. A validate+fixer has been added to update old modules to include this new functionality.\0A#737 New progress VI for headless validation. The 'Obtain Progress Events.vi' will be on the DQMH Scripting palette and will allow the user to monitor the progress of a headless validation via events.\0A\0A\0A### DQMH Thermal Chamber Examples\0A#752 Add semaphores to singleton modules. Project Template, CML Template, and Module Template updated to include semaphore synchronization in all their semaphore modules. There is also a validate+fixer to detect this issue in older modules and update them.\0A#729 New 'Show Diagram on Init' data member All our shipping modules (Project Template, CML Template, Module Template, and shipping example) have been updated to have a new 'show main VI diagram on init' checkbox on their testers. This parameter is wired to the Start Module VI for those modules and implements the new functionality where, on startup, the module main VI diagram is displayed and Retain Wire Values is enabled. A validate+fixer has been added to update old modules to include this new functionality.\0A#723 About VI. There is now an 'About DQMH' VI in the DQMH palette. The Project Template, CML Template, Module Template, and Shipping Example have all been updated with a button in various UIs to launch the About box.\0A\0A\0A### DQMH CML Project Template\0A#752 Add semaphores to singleton modules. Project Template, CML Template, and Module Template updated to include semaphore synchronization in all their semaphore modules. There is also a validate+fixer to detect this issue in older modules and update them.\0A#729 New 'Show Diagram on Init' data member All our shipping modules (Project Template, CML Template, Module Template, and shipping example) have been updated to have a new 'show main VI diagram on init' checkbox on their testers. This parameter is wired to the Start Module VI for those modules and implements the new functionality where, on startup, the module main VI diagram is displayed and Retain Wire Values is enabled. A validate+fixer has been added to update old modules to include this new functionality.\0A#723 About VI. There is now an 'About DQMH' VI in the DQMH palette. The Project Template, CML Template, Module Template, and Shipping Example have all been updated with a button in various UIs to launch the About box.\0A\0A\0A### Help\0A- Updated link to obtain DQMH Framework Badge\0A- Replaced all the instructions to go to Tools>Delacor> to Tools>DQMH Consortium>DQMH to use DQMH Toolkit\0A- Updated video link to Validating an Existing DQMH Module that shows the new features for DQMH 6.1 and how to validate an existing DQMH 6.0 project to match DQMH 6.1\0A- Updated New Module Dialog Image showing the new fields on DQMH 6.1 release.\0A- Added Using Quick Drop Section.\0A- Added DQMH New Menu to the list of Third Party Products\0A- Updated DQMH in LabVIEW Real-Time section\0A- Updated URLs from delacor.com to the equivalent content on dqmh.org\0A- Changed the footer to have clickable text elements instead of showing URLs\0A- Updated Release Notes URLs in What is New in DQMH? section\0A- Added link to https://dqmh.org/training from How to Learn DQMH section\0A- Removed build number from DQMH Versions 4.0 and greater in the Change History section\0A- Published documentation at https://documentation.dqmh.org"
System Package="FALSE"
Sub Package="FALSE"
License Agreement="TRUE"


[LabVIEW]
close labview before install="FALSE"
restart labview after install="FALSE"
skip mass compile after install="FALSE"


[Platform]
Exclusive_LabVIEW_Version="LabVIEW>=15.0"
Exclusive_LabVIEW_System="ALL"
Exclusive_OS="ALL"


[Script VIs]
PreInstall=""
PostInstall="<OS Boot Volume Root>\\GitClones\\dqmh_toolkit\\Post-Install Custom Action.vi"
PreUninstall=""
PostUninstall="<OS Boot Volume Root>\\GitClones\\dqmh_toolkit\\Post-Uninstall Custom Action.vi"
Verify=""
PreBuild=""
PostBuild=""


[Dependencies]
AutoReqProv=FALSE
Requires="delacor_lib_delacor_qmh_event_scripter>=6.1.0.128,delacor_lib_qmh>=6.1.0.18,delacor_lib_qmh_project_template>=6.1.0.94,delacor_lib_qmh_temperature_chamber_examples>=6.1.0.51"
Conflicts=""


[Activation]
License File=""
Licensed Library=""


[Files]
Num File Groups="1"
Sub-Packages=""
Namespaces="44514D485F"


[File Group 0]
Target Dir="<application>"
Replace Mode="Always"
Num Files=62
File 0="vi.lib/Delacor/Delacor QMH Toolkit/DQMH_DQMH Tree.vi"
File 1="resource/plugins/PopupMenus/edit time panel and diagram/Find DQMH Broadcast Event Frames.llb"
File 2="resource/dialog/QuickDrop/plugins/Launch DQMH Tool.vi"
File 3="examples/DQMH Consortium/DQMH Template Example/CreateDQMHFromTemplate.lvproj"
File 4="examples/DQMH Consortium/DQMH Template Example/DQMH Template Example.xml"
File 5="examples/DQMH Consortium/DQMH Template Example/README.txt"
File 6="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Acquire Module Semaphore.vi"
File 7="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Broadcast Events--cluster.ctl"
File 8="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Close Module.vi"
File 9="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Destroy Broadcast Events.vi"
File 10="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Destroy Module Semaphore Reference.vi"
File 11="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Destroy Request Events.vi"
File 12="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Destroy Sync Refnums.vi"
File 13="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Did Init Argument--cluster.ctl"
File 14="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/DQMH Template Example.lvlib"
File 15="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Error Reported Argument--cluster.ctl"
File 16="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Error Reported.vi"
File 17="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Get Module Execution Status Argument--cluster.ctl"
File 18="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Get Module Execution Status.vi"
File 19="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Get Module Main VI Information.vi"
File 20="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Get Status.vi"
File 21="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Get Sync Refnums.vi"
File 22="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Handle Exit.vi"
File 23="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Hide Panel Argument--cluster.ctl"
File 24="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Hide Panel.vi"
File 25="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Hide VI Panel.vi"
File 26="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Init Module.vi"
File 27="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Main.vi"
File 28="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Data--cluster.ctl"
File 29="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Data.lvclass"
File 30="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Did Init.vi"
File 31="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Did Stop.vi"
File 32="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Name--constant.vi"
File 33="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Not Running--error.vi"
File 34="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Not Stopped--error.vi"
File 35="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Not Synced--error.vi"
File 36="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Module Timeout--constant.vi"
File 37="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Null Broadcast Events--constant.vi"
File 38="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Obtain Broadcast Events for Registration.vi"
File 39="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Obtain Broadcast Events.vi"
File 40="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Obtain Module Semaphore.vi"
File 41="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Obtain Request Events.vi"
File 42="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Open VI Panel.vi"
File 43="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Release Module Semaphore.vi"
File 44="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Request and Wait for Reply Timeout--error.vi"
File 45="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Request Events--cluster.ctl"
File 46="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Set Status.vi"
File 47="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Show Diagram Argument--cluster.ctl"
File 48="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Show Diagram.vi"
File 49="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Show Panel Argument--cluster.ctl"
File 50="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Show Panel.vi"
File 51="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Start Module.vi"
File 52="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Status Updated Argument--cluster.ctl"
File 53="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Status Updated.vi"
File 54="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Stop Argument--cluster.ctl"
File 55="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Stop Module.vi"
File 56="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Synchronize Caller Events.vi"
File 57="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Synchronize Module Events.vi"
File 58="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Test DQMH Template Example API.vi"
File 59="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Update Module Execution Status.vi"
File 60="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Wait on Event Sync.vi"
File 61="examples/DQMH Consortium/DQMH Template Example/Libraries/DQMH Template Example/Wait on Module Sync.vi"
